// Code generated by Kitex v1.9.3. DO NOT EDIT.

package demoapiservice

import (
	"code.byted.org/kite/kitex/client"
	kitex "code.byted.org/kite/kitex/pkg/serviceinfo"
	"code.byted.org/libo.1220/libo.1220_api/kitex_gen/motor/ad/libo_api"
	"context"
)

func serviceInfo() *kitex.ServiceInfo {
	return demoApiServiceServiceInfo
}

var demoApiServiceServiceInfo = newServiceInfo()

func newServiceInfo() *kitex.ServiceInfo {
	serviceName := "DemoApiService"
	handlerType := (*libo_api.DemoApiService)(nil)
	methods := map[string]kitex.MethodInfo{
		"SayHi": kitex.NewMethodInfo(sayHiHandler, newDemoApiServiceSayHiArgs, newDemoApiServiceSayHiResult, false),
	}
	extra := map[string]interface{}{
		"PackageName": "libo_api",
	}
	svcInfo := &kitex.ServiceInfo{
		ServiceName:     serviceName,
		HandlerType:     handlerType,
		Methods:         methods,
		PayloadCodec:    kitex.Thrift,
		KiteXGenVersion: "v1.9.3",
		Extra:           extra,
	}
	return svcInfo
}

func sayHiHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	realArg := arg.(*libo_api.DemoApiServiceSayHiArgs)
	realResult := result.(*libo_api.DemoApiServiceSayHiResult)
	success, err := handler.(libo_api.DemoApiService).SayHi(ctx, realArg.Request)
	if err != nil {
		return err
	}
	realResult.Success = success
	return nil
}
func newDemoApiServiceSayHiArgs() interface{} {
	return libo_api.NewDemoApiServiceSayHiArgs()
}

func newDemoApiServiceSayHiResult() interface{} {
	return libo_api.NewDemoApiServiceSayHiResult()
}

type kClient struct {
	c client.Client
}

func newServiceClient(c client.Client) *kClient {
	return &kClient{
		c: c,
	}
}

func (p *kClient) SayHi(ctx context.Context, request *libo_api.DemoApiReq) (r *libo_api.DemoApiResp, err error) {
	var _args libo_api.DemoApiServiceSayHiArgs
	_args.Request = request
	var _result libo_api.DemoApiServiceSayHiResult
	if err = p.c.Call(ctx, "SayHi", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}
